diff --git a/src/main/java/net/minecraft/client/entity/player/EntityOtherPlayerMP.java b/src/main/java/net/minecraft/client/entity/player/RemotePlayer.java
similarity index 73%
rename from src/main/java/net/minecraft/client/entity/player/EntityOtherPlayerMP.java
rename to src/main/java/net/minecraft/client/entity/player/RemotePlayer.java
index c46763e1e..8d599b232 100644
--- a/src/main/java/net/minecraft/client/entity/player/EntityOtherPlayerMP.java
+++ b/src/main/java/net/minecraft/client/entity/player/RemotePlayer.java
@@ -2,11 +2,11 @@ package net.minecraft.client.entity.player;
 
 
 // Referenced classes of package net.minecraft.src:
-//            EntityPlayer, MathHelper, ItemStack, InventoryPlayer, 
+//            Player, MathHelper, ItemStack, InventoryPlayer,
 //            World, Entity
 
 import net.minecraft.core.entity.Entity;
-import net.minecraft.core.entity.player.EntityPlayer;
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.MathHelper;
 import com.mojang.nbt.CompoundTag;
@@ -14,18 +14,24 @@ import net.minecraft.core.world.World;
 import net.minecraft.core.util.helper.DamageType;
 import net.minecraft.core.util.helper.GetSkinUrlThread;
 
-public class EntityOtherPlayerMP extends EntityPlayer
+public class RemotePlayer extends Player
 {
-
-    public EntityOtherPlayerMP(World world, String s)
+    private int lerpSteps;
+    private double lerpX;
+    private double lerpY;
+    private double lerpZ;
+    private double lerpYRot;
+    private double lerpXRot;
+//    float fallTime;
+    public RemotePlayer(World world, String username)
     {
         super(world);
-        field_20924_a = 0.0F;
-        username = s;
+//        fallTime = 0.0F;
+        this.username = username;
         heightOffset = 0.0F;
         footSize = 0.0F;
         noPhysics = true;
-        field_22062_y = 0.25F;
+        sleepOffY = 0.25F;
         viewScale = 10D;
         
         new GetSkinUrlThread(this);
@@ -52,25 +58,25 @@ public class EntityOtherPlayerMP extends EntityPlayer
         lerpZ = z;
         lerpYRot = yRot;
         lerpXRot = xRot;
-        lerpTicks = ticks;
+        lerpSteps = ticks;
     }
 
     @Override
 	public void tick()
     {
-        field_22062_y = 0.0F;
+        sleepOffY = 0.0F;
         super.tick();
-        prevLimbYaw = limbYaw;
+        walkAnimSpeedO = walkAnimSpeed;
         xd = x - xo;
         yd = y - yo;
         zd = z - zo;
-        float f = MathHelper.sqrt_double(xd * xd + zd * zd) * 4F;
+        float f = MathHelper.sqrt(xd * xd + zd * zd) * 4F;
         if(f > 1.0F)
         {
             f = 1.0F;
         }
-        limbYaw += (f - limbYaw) * 0.4F;
-        limbSwing += limbYaw;
+        walkAnimSpeed += (f - walkAnimSpeed) * 0.4F;
+        walkAnimPos += walkAnimSpeed;
     }
 
     @Override
@@ -87,21 +93,21 @@ public class EntityOtherPlayerMP extends EntityPlayer
     @Override
 	public void onLivingUpdate()
     {
-        super.updatePlayerActionState();
-        if(lerpTicks > 0)
+        super.updateAI();
+        if(lerpSteps > 0)
         {
-            double d = x + (lerpX - x) / (double) lerpTicks;
-            double d1 = y + (lerpY - y) / (double) lerpTicks;
-            double d2 = z + (lerpZ - z) / (double) lerpTicks;
+            double d = x + (lerpX - x) / (double) lerpSteps;
+            double d1 = y + (lerpY - y) / (double) lerpSteps;
+            double d2 = z + (lerpZ - z) / (double) lerpSteps;
             double d3 = MathHelper.normalizeRotation(lerpYRot - (double) yRot);
-            yRot += d3 / (double) lerpTicks;
-            xRot += (lerpXRot - (double) xRot) / (double) lerpTicks;
-            lerpTicks--;
+            yRot += d3 / (double) lerpSteps;
+            xRot += (lerpXRot - (double) xRot) / (double) lerpSteps;
+            lerpSteps--;
             setPos(d, d1, d2);
             setRot(yRot, xRot);
         }
         cameraVelocityOld = cameraVelocity;
-        float horizontalSpeed = MathHelper.sqrt_double(xd * xd + zd * zd);
+        float horizontalSpeed = MathHelper.sqrt(xd * xd + zd * zd);
         float f1 = (float) Math.atan(-yd * 0.2D) * 15F;
         if(horizontalSpeed > 0.1F)
         {
@@ -149,12 +155,4 @@ public class EntityOtherPlayerMP extends EntityPlayer
 	public void sendStatusMessage(String message) {
 		
 	}
-
-    private int lerpTicks;
-    private double lerpX;
-    private double lerpY;
-    private double lerpZ;
-    private double lerpYRot;
-    private double lerpXRot;
-    float field_20924_a;
 }
diff --git a/src/main/java/net/minecraft/client/gui/ControllerGlyphRenderer.java b/src/main/java/net/minecraft/client/gui/ControllerGlyphRenderer.java
new file mode 100644
index 000000000..a6f630e3d
--- /dev/null
+++ b/src/main/java/net/minecraft/client/gui/ControllerGlyphRenderer.java
@@ -0,0 +1,119 @@
+package net.minecraft.client.gui;
+
+import net.minecraft.client.Minecraft;
+import net.minecraft.client.input.controller.Button;
+import net.minecraft.client.input.controller.ControllerInput;
+
+public class ControllerGlyphRenderer extends Gui {
+    private final Minecraft minecraft;
+
+    public ControllerGlyphRenderer(Minecraft minecraft) {
+        this.minecraft = minecraft;
+    }
+
+    public void drawButton(ControllerInput controller, Button button, int x, int y, boolean pressed) {
+        int u = getButtonU(controller, button);
+        int v = getButtonV(controller, button);
+        int sizeU = getButtonSizeU(controller, button);
+        int sizeV = getButtonSizeV(controller, button);
+        int vOffset = 0;
+        if (pressed) {
+            vOffset = sizeV;
+        }
+
+
+        minecraft.renderEngine.loadTexture("/assets/minecraft/textures/gui/controller/" + controller.getType().getAssetName() + ".png").bind();
+
+        drawTexturedModalRect(x, y, u, v + vOffset, sizeU, sizeV);
+    }
+
+    public void drawDPad(ControllerInput controllerInput, int x, int y, boolean up, boolean right, boolean down, boolean left) {
+        int u = 0;
+        int v = 72;
+        int sizeU = 46;
+        int sizeV = 46;
+
+        minecraft.renderEngine.loadTexture("/assets/minecraft/textures/gui/controller/" + controllerInput.getType().getAssetName() + ".png").bind();
+
+        drawTexturedModalRect(x, y, u, v, sizeU, sizeV);
+
+        if (up) {
+            drawTexturedModalRect(x, y, 46, 72, 46, 15);
+        }
+        if (right) {
+            drawTexturedModalRect(x + 31, y, 77, 72, 15, 46);
+        }
+        if (down) {
+            drawTexturedModalRect(x, y + 31, 46, 103, 46, 15);
+        }
+        if (left) {
+            drawTexturedModalRect(x, y, 46, 72, 15, 46);
+        }
+    }
+
+    private int getButtonU(ControllerInput controller, Button button) {
+        if (button == controller.buttonA || button == controller.digitalPad.up) {
+            return 0;
+        } else if (button == controller.buttonB || button == controller.digitalPad.right) {
+            return 18;
+        } else if (button == controller.buttonX || button == controller.digitalPad.down) {
+            return 36;
+        } else if (button == controller.buttonY || button == controller.digitalPad.left) {
+            return 54;
+        } else if (button == controller.buttonLeftShoulder) {
+            return 97;
+        } else if (button == controller.buttonRightShoulder) {
+            return 72;
+        } else if (button == controller.buttonLeftTrigger) {
+            return 139;
+        } else if (button == controller.buttonRightTrigger) {
+            return 122;
+        } else if (button == controller.buttonStart) {
+            return 72;
+        } else if (button == controller.buttonBack) {
+            return 87;
+        } else {
+            return 0;
+        }
+    }
+
+    private int getButtonV(ControllerInput controller, Button button) {
+        if (button == controller.buttonA || button == controller.buttonB || button == controller.buttonX || button == controller.buttonY || button == controller.buttonLeftShoulder || button == controller.buttonRightShoulder || button == controller.buttonLeftTrigger || button == controller.buttonRightTrigger) {
+            return 0;
+        } else if (button == controller.digitalPad.up || button == controller.digitalPad.right || button == controller.digitalPad.down || button == controller.digitalPad.left) {
+            return 36;
+        } else if (button == controller.buttonStart || button == controller.buttonBack) {
+            return 26;
+        } else {
+            return 0;
+        }
+    }
+
+    public int getButtonSizeU(ControllerInput controller, Button button) {
+        if (button == controller.buttonA || button == controller.buttonB || button == controller.buttonX || button == controller.buttonY || button == controller.digitalPad.up || button == controller.digitalPad.right || button == controller.digitalPad.down || button == controller.digitalPad.left) {
+            return 18;
+        } else if (button == controller.buttonLeftShoulder || button == controller.buttonRightShoulder) {
+            return 25;
+        } else if (button == controller.buttonLeftTrigger || button == controller.buttonRightTrigger) {
+            return 17;
+        } else if (button == controller.buttonStart || button == controller.buttonBack) {
+            return 15;
+        } else {
+            return 0;
+        }
+    }
+
+    public int getButtonSizeV(ControllerInput controller, Button button) {
+        if (button == controller.buttonA || button == controller.buttonB || button == controller.buttonX || button == controller.buttonY || button == controller.digitalPad.up || button == controller.digitalPad.right || button == controller.digitalPad.down || button == controller.digitalPad.left) {
+            return 18;
+        } else if (button == controller.buttonLeftShoulder || button == controller.buttonRightShoulder) {
+            return 13;
+        } else if (button == controller.buttonLeftTrigger || button == controller.buttonRightTrigger) {
+            return 15;
+        } else if (button == controller.buttonStart || button == controller.buttonBack) {
+            return 15;
+        } else {
+            return 0;
+        }
+    }
+}
diff --git a/src/main/java/net/minecraft/client/gui/Gui.java b/src/main/java/net/minecraft/client/gui/Gui.java
index 73c52c8db..f7256c09a 100644
--- a/src/main/java/net/minecraft/client/gui/Gui.java
+++ b/src/main/java/net/minecraft/client/gui/Gui.java
@@ -5,11 +5,18 @@ import static org.lwjgl.opengl.GL11.*;
 import net.minecraft.client.lang.text.Text;
 import net.minecraft.client.render.FontRenderer;
 import net.minecraft.client.render.RenderEngine;
-import net.minecraft.client.render.stitcher.IconCoordinate;
+import net.minecraft.client.render.texture.Texture;
+import net.minecraft.client.render.texture.meta.gui.GuiTextureProperties;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.tessellator.Tessellator;
 
+import net.minecraft.client.render.texture.stitcher.TextureRegistry;
+import net.minecraft.core.util.helper.Color;
+import net.minecraft.core.util.helper.MathHelper;
 import org.lwjgl.opengl.GL11;
 
+import java.util.Objects;
+
 public class Gui
 {
 
@@ -29,6 +36,17 @@ public class Gui
         drawRect(minX, minY, maxX + 1, minY + 1, argb);
     }
 
+    protected void drawLineHorizontalDouble(double minX, double maxX, double minY, int argb)
+    {
+        if(maxX < minX)
+        {
+            double temp = minX;
+            minX = maxX;
+            maxX = temp;
+        }
+        drawRectDouble(minX, minY, maxX + 1, minY + 1, argb);
+    }
+
     protected void drawLineVertical(int minX, int minY, int maxY, int argb)
     {
         if(maxY < minY)
@@ -40,6 +58,17 @@ public class Gui
         drawRect(minX, minY + 1, minX + 1, maxY, argb);
     }
 
+    protected void drawLineVerticalDouble(double minX, double minY, double maxY, int argb)
+    {
+        if(maxY < minY)
+        {
+            double temp = minY;
+            minY = maxY;
+            maxY = temp;
+        }
+        drawRectDouble(minX, minY + 1, minX + 1, maxY, argb);
+    }
+
     protected void drawRect(int minX, int minY, int maxX, int maxY, int argb)
     {
         if(minX < maxX)
@@ -64,10 +93,42 @@ public class Gui
         GL11.glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
         GL11.glColor4f(r, g, b, a);
         tessellator.startDrawingQuads();
-        tessellator.addVertex(minX, maxY, 0.0D);
-        tessellator.addVertex(maxX, maxY, 0.0D);
-        tessellator.addVertex(maxX, minY, 0.0D);
-        tessellator.addVertex(minX, minY, 0.0D);
+        tessellator.addVertex(minX, maxY, zLevel);
+        tessellator.addVertex(maxX, maxY, zLevel);
+        tessellator.addVertex(maxX, minY, zLevel);
+        tessellator.addVertex(minX, minY, zLevel);
+        tessellator.draw();
+        GL11.glEnable(GL_TEXTURE_2D);
+        GL11.glDisable(GL_BLEND);
+    }
+    protected void drawRectDouble(double minX, double minY, double maxX, double maxY, int argb)
+    {
+        if(minX < maxX)
+        {
+            double temp = minX;
+            minX = maxX;
+            maxX = temp;
+        }
+        if(minY < maxY)
+        {
+            double temp = minY;
+            minY = maxY;
+            maxY = temp;
+        }
+        float a = (float)(argb >> 24 & 0xff) / 255F;
+        float r = (float)(argb >> 16 & 0xff) / 255F;
+        float g = (float)(argb >> 8 & 0xff) / 255F;
+        float b = (float)(argb & 0xff) / 255F;
+        Tessellator tessellator = Tessellator.instance;
+        GL11.glEnable(GL_BLEND);
+        GL11.glDisable(GL_TEXTURE_2D);
+        GL11.glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
+        GL11.glColor4f(r, g, b, a);
+        tessellator.startDrawingQuads();
+        tessellator.addVertex(minX, maxY, zLevel);
+        tessellator.addVertex(maxX, maxY, zLevel);
+        tessellator.addVertex(maxX, minY, zLevel);
+        tessellator.addVertex(minX, minY, zLevel);
         tessellator.draw();
         GL11.glEnable(GL_TEXTURE_2D);
         GL11.glDisable(GL_BLEND);
@@ -203,20 +264,71 @@ public class Gui
         float vScale = 0.00390625F;
         Tessellator tessellator = Tessellator.instance;
         tessellator.startDrawingQuads();
-        tessellator.addVertexWithUV(x + 0, y + height, zLevel, (float)(u + 0) * uScale, (float)(v + height) * vScale);
-        tessellator.addVertexWithUV(x + width, y + height, zLevel, (float)(u + width) * uScale, (float)(v + height) * vScale);
-        tessellator.addVertexWithUV(x + width, y + 0, zLevel, (float)(u + width) * uScale, (float)(v + 0) * vScale);
-        tessellator.addVertexWithUV(x + 0, y + 0, zLevel, (float)(u + 0) * uScale, (float)(v + 0) * vScale);
+        tessellator.addVertexWithUV(x + 0, y + height, zLevel, (u + 0) * uScale, (v + height) * vScale);
+        tessellator.addVertexWithUV(x + width, y + height, zLevel, (u + width) * uScale, (v + height) * vScale);
+        tessellator.addVertexWithUV(x + width, y + 0, zLevel, (u + width) * uScale, (v + 0) * vScale);
+        tessellator.addVertexWithUV(x + 0, y + 0, zLevel, (u + 0) * uScale, (v + 0) * vScale);
         tessellator.draw();
     }
     public void drawTexturedModalRect(int x, int y, int u, int v, int width, int height, double uScale, double vScale)
     {
+        final double off = 0.05d;
+        Tessellator tessellator = Tessellator.instance;
+        tessellator.startDrawingQuads();
+        tessellator.addVertexWithUV(x - off,        y + height + off,   zLevel, (u + 0) * uScale,        (v + height) * vScale);
+        tessellator.addVertexWithUV(x + width + off,y + height + off,   zLevel, (u + width) * uScale,    (v + height) * vScale);
+        tessellator.addVertexWithUV(x + width + off,y - off,            zLevel, (u + width) * uScale,    (v + 0) * vScale);
+        tessellator.addVertexWithUV(x - off,        y - off,            zLevel, (u + 0) * uScale,        (v + 0) * vScale);
+        tessellator.draw();
+    }
+    public void drawTexturedModalRectDouble(double x, double y, double u, double v, double width, double height, double uScale, double vScale)
+    {
+        final double off = 0.05d;
         Tessellator tessellator = Tessellator.instance;
         tessellator.startDrawingQuads();
-        tessellator.addVertexWithUV(x + 0, y + height, zLevel, (float)(u + 0) * uScale, (float)(v + height) * vScale);
-        tessellator.addVertexWithUV(x + width, y + height, zLevel, (float)(u + width) * uScale, (float)(v + height) * vScale);
-        tessellator.addVertexWithUV(x + width, y + 0, zLevel, (float)(u + width) * uScale, (float)(v + 0) * vScale);
-        tessellator.addVertexWithUV(x + 0, y + 0, zLevel, (float)(u + 0) * uScale, (float)(v + 0) * vScale);
+        tessellator.addVertexWithUV(x - off,        y + height + off,   zLevel, (u + 0) * uScale,        (v + height) * vScale);
+        tessellator.addVertexWithUV(x + width + off,y + height + off,   zLevel, (u + width) * uScale,    (v + height) * vScale);
+        tessellator.addVertexWithUV(x + width + off,y - off,            zLevel, (u + width) * uScale,    (v + 0) * vScale);
+        tessellator.addVertexWithUV(x - off,        y - off,            zLevel, (u + 0) * uScale,        (v + 0) * vScale);
+        tessellator.draw();
+    }
+
+    public void drawTexturedModalRect(int x, int y, int u, int v, int width, int height, double uScale, double vScale, double off)
+    {
+        Tessellator tessellator = Tessellator.instance;
+        tessellator.startDrawingQuads();
+        tessellator.addVertexWithUV(x - off,        y + height + off,   zLevel, (u + 0) * uScale,        (v + height) * vScale);
+        tessellator.addVertexWithUV(x + width + off,y + height + off,   zLevel, (u + width) * uScale,    (v + height) * vScale);
+        tessellator.addVertexWithUV(x + width + off,y - off,            zLevel, (u + width) * uScale,    (v + 0) * vScale);
+        tessellator.addVertexWithUV(x - off,        y - off,            zLevel, (u + 0) * uScale,        (v + 0) * vScale);
+        tessellator.draw();
+    }
+
+    public void drawTexturedModalRectDouble(double x, double y, double u, double v, double width, double height, double uScale, double vScale, double off)
+    {
+        final double foon = /*(0.25d * uScale)*/0;
+        final double goon = /*(0.25d * vScale)*/0;
+        Tessellator tessellator = Tessellator.instance;
+        tessellator.startDrawingQuads();
+        tessellator.addVertexWithUV(x - off,        y + height + off,   zLevel, (u + 0.5) * uScale,       (v + height) * vScale);
+        tessellator.addVertexWithUV(x + width + off,y + height + off,   zLevel, (u + width - 0.5) * uScale,   (v + height) * vScale);
+        tessellator.addVertexWithUV(x + width + off,y - off,            zLevel, (u + width - 0.5) * uScale,    v * vScale);
+        tessellator.addVertexWithUV(x - off,        y - off,            zLevel, (u + 0.5) * uScale,        v * vScale);
+        tessellator.draw();
+    }
+
+
+    public void drawTexturedModalRectDouble(double x, double y, double u, double v, double width, double height, double uWidth, double vHeight, double uScale, double vScale)
+    {
+        final double foon = (0.5f * uScale);
+        final double goon = 0.0625f * (16.0f / uWidth);
+        final double off = 0.05d;
+        Tessellator tessellator = Tessellator.instance;
+        tessellator.startDrawingQuads();
+        tessellator.addVertexWithUV(x - off,        y + height + off,   zLevel, (u + foon) * uScale,             (v + vHeight - foon) * vScale);
+        tessellator.addVertexWithUV(x + width + off,y + height + off,   zLevel, (u + uWidth - foon) * uScale,    (v + vHeight - foon) * vScale);
+        tessellator.addVertexWithUV(x + width + off,y - off,            zLevel, (u + uWidth - foon) * uScale,    (v + foon) * vScale);
+        tessellator.addVertexWithUV(x - off,        y - off,            zLevel, (u + foon) * uScale,             (v + foon) * vScale);
         tessellator.draw();
     }
 
@@ -226,10 +338,10 @@ public class Gui
         float vScale = 0.00390625F;
         Tessellator tessellator = Tessellator.instance;
         tessellator.startDrawingQuads();
-        tessellator.addVertexWithUV(x + 0, y + height, zLevel, (float)(u + 0) * uScale, (float)(v + uvHeight) * vScale);
-        tessellator.addVertexWithUV(x + width, y + height, zLevel, (float)(u + uvWidth) * uScale, (float)(v + uvHeight) * vScale);
-        tessellator.addVertexWithUV(x + width, y + 0, zLevel, (float)(u + uvWidth) * uScale, (float)(v + 0) * vScale);
-        tessellator.addVertexWithUV(x + 0, y + 0, zLevel, (float)(u + 0) * uScale, (float)(v + 0) * vScale);
+        tessellator.addVertexWithUV(x + 0, y + height, zLevel, (u + 0) * uScale, (v + uvHeight) * vScale);
+        tessellator.addVertexWithUV(x + width, y + height, zLevel, (u + uvWidth) * uScale, (v + uvHeight) * vScale);
+        tessellator.addVertexWithUV(x + width, y + 0, zLevel, (u + uvWidth) * uScale, (v + 0) * vScale);
+        tessellator.addVertexWithUV(x + 0, y + 0, zLevel, (u + 0) * uScale, (v + 0) * vScale);
         tessellator.draw();
     }
     
@@ -239,15 +351,15 @@ public class Gui
         float vScale = scale;
         Tessellator tessellator = Tessellator.instance;
         tessellator.startDrawingQuads();
-        tessellator.addVertexWithUV(x + 0, y + height, zLevel, (float)(u + 0) * uScale, (float)(v + uvWidth) * vScale);
-        tessellator.addVertexWithUV(x + width, y + height, zLevel, (float)(u + uvWidth) * uScale, (float)(v + uvWidth) * vScale);
-        tessellator.addVertexWithUV(x + width, y + 0, zLevel, (float)(u + uvWidth) * uScale, (float)(v + 0) * vScale);
-        tessellator.addVertexWithUV(x + 0, y + 0, zLevel, (float)(u + 0) * uScale, (float)(v + 0) * vScale);
+        tessellator.addVertexWithUV(x + 0, y + height, zLevel, (u + 0) * uScale, (v + uvWidth) * vScale);
+        tessellator.addVertexWithUV(x + width, y + height, zLevel, (u + uvWidth) * uScale, (v + uvWidth) * vScale);
+        tessellator.addVertexWithUV(x + width, y + 0, zLevel, (u + uvWidth) * uScale, (v + 0) * vScale);
+        tessellator.addVertexWithUV(x + 0, y + 0, zLevel, (u + 0) * uScale, (v + 0) * vScale);
         tessellator.draw();
     }
     public void drawTexturedIcon(int x, int y, int width, int height, IconCoordinate coordinate)
     {
-        coordinate.parentAtlas.bindTexture();
+        coordinate.parentAtlas.bind();
         Tessellator tessellator = Tessellator.instance;
         tessellator.startDrawingQuads();
         tessellator.addVertexWithUV(x + 0,      y + height, zLevel, coordinate.getIconUMin(), coordinate.getIconVMax());
